/// Native `url(..)` function wrapper
/// @param {String} $base - base URL for the asset
/// @param {String} $type - asset type folder (e.g. `fonts/`)
/// @param {String} $path - asset path
/// @return {Url} --
@function asset($base, $type, $path) {
  @return url($base ) $type + $path;;
}

/// Returns URL to an image based on its path
/// @param {String} $path - image path
/// @param {String} $base [$base-url] - base URL
/// @return {Url}
/// @require $base-url
@function image($path, $base: $base-url) {
  @return asset($base, "images/", $path);
}

/// Returns URL to a font based on its path
/// @param {String} $path - font path
/// @param {String} $base [$base-url] - base URL
/// @return {Url}
/// @require $base-url
@function font($path, $base: $base-url) {
  @return asset($base, "fonts/", $path);
}

///
@function convert($value, $convertUnit, $convertBase: $convertBase) {
  $currentUnit: unit($value);
  $strippedValue: $value / ($value * 0 + 1);
  @if not unitless($convertBase) {
    @if unit($convertBase) != px {
      @error "Not supported unit '#{unit($convertBase)}' as convert base!";
    }
    $convertBase: $convertBase / ($convertBase * 0 + 1);
  }

  @if $currentUnit == px {
    @if $convertUnit == "em" {
      @return 0em + ($strippedValue / $convertBase);
    }
    @else if $convertUnit == "%" {
      @return percentage($strippedValue / $convertBase);
    }
  }
  @else if $currentUnit == em {
    @if $convertUnit == "px" {
      @return 0px + ($strippedValue * $convertBase);
    }
    @else if $convertUnit == "%" {
      @return percentage($strippedValue);
    }
  }
  @else if $currentUnit == "%" {
    @if $convertUnit == "px" {
      @return 0em + ($strippedValue * $convertBase / 100);
    }
    @else if $convertUnit == "em" {
      @return 0em + ($strippedValue / 100);
    }
  }
  // TODO: Check for pt unit convert
  @else if $currentUnit == pt {
    @if $convertUnit == "px" {
      @return 0px + ($strippedValue * 1.3333);
    }
    @else if $convertUnit == "em" {
      @return 0em + ($strippedValue / 12);
    }
    @else if $convertUnit == "%" {
      @return percentage($strippedValue / 12)
    }
  }
  @error "Can't convert '#{$value}' to unit '#{$convertUnit}'!";
}

/// Returns HEXADECIMAL COLORS -- https://webdesign.tutsplus.com/pt/tutorials/all-you-ever-need-to-know-about-sass-interpolation--cms-21375
/// @param {String} $key - color name
/// @return {String} - hexadecimal color
/// @require $key
@function color($key) {
  @if not map-has-key($colors, $key) {
    @warn "Key `#{$key}` not found in $colors map.";
  }
  @return map-get($colors, $key);
}
